;===========================================================================================
; Avi.asm  GoAsm assembler
; Excuter un fichier .avi  
; Construction manuelle de Animate32 class
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\avi.rc
; ..\..\bin\GoAsm avi.asm
; ..\..\bin\GoLink avi.obj res\avi.res user32.dll kernel32.dll gdi32.dll comctl32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE  = 17

  ID_GBOX    = 100
  ID_ANIMATE = 101

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

 start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne spcifique
    ; ---------------------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur systme
    ; -------------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fenetre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,0,addr ClassName,addr Titre,WS_CAPTION+WS_POPUP+WS_SYSMENU \
                         +WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affiche et rafraichit la fenetre
    ; --------------------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWnd]

 ; Boucle des messages
 ; -------------------
 MessageLoop:
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmcreate
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande fin d'application
        ; -------------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmcreate:
    cmp D[@uMsg],WM_CREATE
    jne >.defwindowproc
        ; Assure que la bibliothque de liaison dynamique de contrle commune est charge
        ; -------------------------------------------------------------------------------
        mov D[icex.dwSize],sizeof INITCOMMONCONTROLSEX
        mov D[icex.dwICC],0FFFFh
        invoke InitCommonControlsEx,addr icex

        ; Dfinir une fonte de texte
        ; --------------------------
        invoke CreateFont,8,0,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,\
                       CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_SWISS,\
                                                                      addr FontMS
        mov [hFontMS],eax                      ;fonte handle

        ; Construit tous les controles
        ; ----------------------------
        invoke CreateControls,[@hWnd]

        ; Demande d'excution du fichier .avi
        ; -----------------------------------
        invoke SendDlgItemMessage,[@hWnd],ID_ANIMATE,ACM_OPEN,[wc.hInstance],addr AviFile
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:

    mov eax,0
    ret
endf

;===========================================================================================
CreateControls frame @hWnd

    ; Cration de la fentre-enfant GroupBox
    ; --------------------------------------
    invoke Dlg,addr Button,addr GbGges,[@hWnd],4,2,286,20,ID_GBOX,BS_GROUPBOX,0

    ;=======================================================================================
    ; Cration de la fentre-enfant pour avi Animate32
    ; ------------------------------------------------
    invoke Dlg,addr Animate32,addr NoText,[@hWnd],66,48,162,128,ID_ANIMATE,WS_TABSTOP \
                                      +ACS_AUTOPLAY,WS_EX_STATICEDGE+WS_EX_CLIENTEDGE

    ret
endf

;===========================================================================================
; Cration d'une fentre-enfant control class
;-------------------------------------------------------------------------------------------
; @Class    = adresse du nom de control class
; @AdrText  = adresse du control text
; @hParent  = handle de la fentre parent
; @X        = x-coordonne fentre-enfant
; @Y        = y-coordonne fentre-enfant
; @Xw       = largeur en pixels fentre-enfant
; @Yh       = hauteur en pixels fentre-enfant
; @Id       = identificateur du controle forme ID_XXX
; @Style    = complment window style de WS_CHILD+WS_VISIBLE
; @ExStyle  = window style tendu
;-------------------------------------------------------------------------------------------
; => eax = handle de la fentre-enfant
;-------------------------------------------------------------------------------------------
Dlg frame @Class, @AdrText, @hParent, @X, @Y, @Xw, @Yh, @Id, @Style, @ExStyle

    mov eax,WS_CHILD+WS_VISIBLE
    add eax,[@Style]
    invoke CreateWindowEx,[@ExStyle],[@Class],[@AdrText],eax,[@X],[@Y],[@Xw],[@Yh],\
                          [@hParent],[@Id],[wc.hInstance],NULL
    mov ebx,eax

    ; Valider la fonte standard MS Sans Serif pour le control
    ; -------------------------------------------------------
    invoke SendMessage,ebx,WM_SETFONT,[hFontMS],NULL
    mov eax,ebx

    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  Titre       db ' ANIMATE32 control',0
  ClassName   db ' AsmGges Win32',0
  MsgEnd      db ' GoAsm AsmGges France @2006  ',0
  GbGges      db 'AsmGges Avi Animate32',0
  NoText      db '',0

  FontMS      db 'MS Sans Serif',0

  Button      db 'BUTTON',0
  Animate32   db 'SysAnimate32',0
  AviFile     db 'res\skeleton.avi',0

  align 4

  WinX        dd 0
  WinY        dd 100
  WinW        dd 300
  WinH        dd 244

  hWnd        dd ?
  hFontMS     dd ?

  wc          WNDCLASS  < 0, addr WindowProc, 0, 0, 0, 0, 0, \
                          COLOR_BTNFACE+1, 0, addr ClassName >
  msg         MSG                  <>
  icex        INITCOMMONCONTROLSEX <>

;===========================================================================================


